/*
  ******************************************************************************
  * @file    fxx_it.c
  * @brief   fxx_it source File.
  ******************************************************************************
*/

#include "fxx_it.h"
#include "app.h"

extern volatile uint32_t gu32_SystemCount; 

/*********************************************************************************
* Function    : HardFault_Handler
* Description : Hard Fault handle, while(1) loop, wait for debug 
* Input       : none 
* Output      : none   
* Author      : xwl                           
**********************************************************************************/  
void HardFault_Handler(void)
{
    while(1);   
} 


/*********************************************************************************
* Function    : SysTick_Handler
* Description : System tick handler
* Input       : none 
* Output      : none 
* Author      : xwl                         
**********************************************************************************/
void SysTick_Handler(void)
{
    gu32_SystemCount++;  
}

void KEY1_IRQHandler(void)
{
    // EXTI Linex INT
    if(EXTI_GetITStatus(KEY1_INT_EXTI_LINE) != RESET) 
    {	
        printfS("This is EXTI_IRQHandler \r\n");
        //Clear EXTI Line INT Flag
        EXTI_ClearITPendingBit(KEY1_INT_EXTI_LINE);     
    }  
    
}