/*
  ******************************************************************************
  * Copyright (c)  2008 - 2022, Shanghai AisinoChip Co.,Ltd .
  * @file    app.h 
  * @version V1.0.0
  * @date    2022
  * @author  Aisinochip Firmware Team  
  * @brief   UART demo Header code.
  ******************************************************************************        
*/
#ifndef __APP_H__
#define __APP_H__

#include "fxx_std.h"   

#define UART_BAUD_RATE  115200   


#define SLAVE_ADDRESS    (0xA6)
#define USER_I2C   I2C2
#define BUFFER_LENGTH    (256)

typedef enum
{
    TEST_SLAVE_POLLING,
    TEST_SLAVE_INTERRUPT,
    TEST_SLAVE_DMA,
}enum_TEST_MODE_t;

extern Slave_Comm_TypeDef    g_SlaveComm;

/* Function : I2C_Slave_Test */
void I2C_Slave_Test(enum_TEST_MODE_t fu8_Mode);

#endif
